package POWER::Event::IO::LISTEN;
use POWER::Event::IO::share;
use base qw( POWER::Event::IO );

use version; $VERSION = qv('0.2.0');    # update POD & Changes & README

use warnings;
use strict;
use Carp;

use Socket;

use POWER::Epoll;


$Class{'POWER::Event::IO::LISTEN'} = {
    event       => $ERR|$RESOLVED|$ACCEPTED,
    style       => $PACKET_IO,
    socktype    => $SOCK_STREAM,
    sockproto   => $PROTO_TCP,
};


sub _real_config {
    my ($self, $io) = @_;
    #       ..   
    #  ,       
    #  EPOLLERR.
    setsockopt($io->{fh}, $SOL_SOCKET, $SO_REUSEADDR, $REUSEADDR_VAL);
    bind($io->{fh}, sockaddr_in($self->{port}, inet_aton($self->{ip})));
    listen($io->{fh}, $SOMAXCONN);
    #  host    DNS ,   _real_config
    #     ,      epoll_add().
    epoll_add($EPFD, $io->{fd}, $io->{_epoll})
        if defined $io->{fd}; # XXX        epoll_add?
    $io->{_state} = $HANDLING;
    return;
}

sub _real_read {
    my ($self) = @_;
    return if defined $self->{in_buf};
    $self->{in_paddr} = accept $self->{in_buf}, $self->{fh};
    if (defined $self->{in_paddr}) {
        ioctl($self->{in_buf}, $FIONBIO, $IOCTL_TRUE) or croak "ioctl: $!";
        $self->{_events}   |= $ACCEPTED;
    }
    elsif ($! != $EAGAIN) {
        $self->{_err}       = $!;
        $self->{_events}   |= $ERR;
    }
    return;
}

sub _real_write {
    die 'Closed. Try again later, please...';
}


1; # Magic true value required at end of module
__END__

=head1 DESCRIPTION

See L<POWER::Event::IO>.
