use warnings;
use strict;
use Test::More tests => 3;
use Test::Exception;
use Test::MockModule;

use Socket;

use POWER::Event;
use POWER::Event::IO;
use POWER::Utils::IO;

my $fifo = "/tmp/fifo.$$";
END { unlink $fifo }
system("mkfifo \Q$fifo\E") and die "system: $!";
open my $tmp, '+>', $fifo or die "open: $!";
open my $rd, '<', $fifo or die "open: $!";
open my $wr, '>', $fifo or die "open: $!";
close $tmp or die "close: $!";
POWER::Event::IO->new({
    fh          => $rd,
    cb          => \&rd,
    wait_for    => $EOF,
    in_buf_limit=> 1024,
});
POWER::Event::IO->new({
    fh          => $wr,
    cb          => \&wr,
    wait_for    => $SENT,
    out_buf     => 'test',
});


eval { loop() };
die "out of loop: $@";

sub wr {
    my ($io) = @_;
    is($io->{events}, $SENT,   'wr: SENT here');
    $io->close();
}

sub rd {
    my ($io) = @_;
    is($io->{events}, $EOF,   'rd: EOF here');
    is($io->{in_buf}, 'test', '    got "test"');
    exit;
}

